<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <style>
        [tooltip]{
            position: relative;
            text-align: center;
            padding: 10px;
            margin: 5% ;
            background-color: grey;
            display: inline-block;
        }

        [tooltip]::before{
            position:absolute;
            content: attr(tooltip);
            background-color: rgba(0,0,0, 0.81);
            color: white;
            width:max-content;
            padding: 7px;  
            border-radius: 4px; 
            visibility: hidden;    /* we can even use display none*/ 
        }
        [tooltip]::after{
            position:absolute;
            box-sizing: border-box;
            content: "";
            border:5px solid ;
            visibility: hidden;
        }
        [tooltip]:hover::before{
            visibility: initial;
            bottom: calc(100% + 5px);
            left:50%;
            transform: translateX(-50%);
        }
        [tooltip]:hover::after{
            visibility: initial;
            bottom: calc(100% - 5px);
            left:50%;
            transform: translateX(-50%);
            border-color: rgba(0,0,0, 0.81) transparent transparent  transparent;
        }
        [tooltip-position="right"]:hover::before{
            visibility: initial;
            left: calc(100% + 5px);
            bottom: 50%;
            transform: translateY(50%);
        }
        [tooltip-position="right"]:hover::after{
            visibility: initial;
            left: calc(100% - 5px);
            bottom: 50%;
            transform: translateY(50%);
            border-color:  transparent rgba(0,0,0, 0.81) transparent  transparent;
        }
        [tooltip-position="left"]:hover::before{
            visibility: initial;
            right: calc(100% + 5px);
            bottom:50%;
            transform: translateY(50%);
            left: initial;
        }
        [tooltip-position="left"]:hover::after{
            visibility: initial;
            left: initial;
            right: calc(100% - 5px);
            bottom: 50%;
            transform: translateY(50%);
            border-color:  transparent  transparent  transparent rgba(0,0,0, 0.81);
        }
        [tooltip-position="bottom"]:hover::before{
            visibility: initial;
            top: calc(100% + 5px);
            left: 50%;
            transform: translateX(-50%);
            bottom: initial;
        }
        [tooltip-position="bottom"]:hover::after{
            visibility: initial;
            top: calc(100% - 5px);
            left: 50%;
            transform: translateX(-50%);
            border-color:  transparent transparent rgba(0,0,0, 0.81) transparent;
        }
    </style>
</head>
<body>
        <div tooltip="tooltip text " tooltip-position="top">Top </div>
        <div tooltip="tooltip text" tooltip-position="left">Left</div>
        <div tooltip="tooltip text" tooltip-position="bottom">Bottom</div>
        <div tooltip="tooltip text" tooltip-position="right">Right</div>
</body>
</html>
